<!--
  This Behavior Tree first computes a path using the global planner (ComputePathToPose).
  Then, it runs two sub-branches in parallel. The first sub-branch is a FollowPath
  operation (the local planner). In parallel, there is a rate controlled execution of
  FollowPath (the global planner). Each time a new path is computed, the path update
  is sent to the local planner. The right branch, which is the rate controlled
  ComputePathToPose, always returns RUNNING. Because the Parallel node uses a
  threshold of 1, whenever the FollowPath returns SUCCESS or FAILURE, the parallel
  node will return this result.

  The goal (input to the global planner) and the resulting path (output of the global
  planner and input to the local planner) are passed on the blackboard.

  The rate at which the ComputePathToPose operation is invoked can be controlled with
  the hz parameter to the RateController node.
-->

<root main_tree_to_execute="MainTree">
  <BehaviorTree ID="MainTree">
   <RecoveryNode number_of_retries="4">
    <Sequence name="root">
      <RateController hz="1.0">
        <Fallback>
          <GoalReached/>
          <ComputePathToPose goal="${goal}"/>
        </Fallback>
      </RateController>
      <FollowPath path="${path}"/>
    </Sequence>
   </RecoveryNode>
  </BehaviorTree>
</root>
